### rbac relationship

This code generated was by RbacViewMermaidFlowchartGenerator at  2024-03-15T17:17:00.854621634.

```mermaid
%%{init:{'flowchart':{'htmlLabels':false}}}%%
flowchart TB

subgraph holderPerson["`**holderPerson**`"]
    direction TB
    style holderPerson fill:#99bcdb,stroke:#274d6e,stroke-width:8px

    subgraph holderPerson:roles[ ]
        style holderPerson:roles fill:#99bcdb,stroke:white

        role:holderPerson:owner[[holderPerson:owner]]
        role:holderPerson:admin[[holderPerson:admin]]
        role:holderPerson:referrer[[holderPerson:referrer]]
    end
end

subgraph anchorPerson["`**anchorPerson**`"]
    direction TB
    style anchorPerson fill:#99bcdb,stroke:#274d6e,stroke-width:8px

    subgraph anchorPerson:roles[ ]
        style anchorPerson:roles fill:#99bcdb,stroke:white

        role:anchorPerson:owner[[anchorPerson:owner]]
        role:anchorPerson:admin[[anchorPerson:admin]]
        role:anchorPerson:referrer[[anchorPerson:referrer]]
    end
end

subgraph contact["`**contact**`"]
    direction TB
    style contact fill:#99bcdb,stroke:#274d6e,stroke-width:8px

    subgraph contact:roles[ ]
        style contact:roles fill:#99bcdb,stroke:white

        role:contact:owner[[contact:owner]]
        role:contact:admin[[contact:admin]]
        role:contact:referrer[[contact:referrer]]
    end
end

subgraph relationship["`**relationship**`"]
    direction TB
    style relationship fill:#dd4901,stroke:#274d6e,stroke-width:8px

    subgraph relationship:roles[ ]
        style relationship:roles fill:#dd4901,stroke:white

        role:relationship:owner[[relationship:owner]]
        role:relationship:admin[[relationship:admin]]
        role:relationship:agent[[relationship:agent]]
        role:relationship:tenant[[relationship:tenant]]
    end

    subgraph relationship:permissions[ ]
        style relationship:permissions fill:#dd4901,stroke:white

        perm:relationship:DELETE{{relationship:DELETE}}
        perm:relationship:UPDATE{{relationship:UPDATE}}
        perm:relationship:SELECT{{relationship:SELECT}}
        perm:relationship:INSERT{{relationship:INSERT}}
    end
end

%% granting roles to users
user:creator ==> role:relationship:owner

%% granting roles to roles
role:global:admin -.-> role:anchorPerson:owner
role:anchorPerson:owner -.-> role:anchorPerson:admin
role:anchorPerson:admin -.-> role:anchorPerson:referrer
role:global:admin -.-> role:holderPerson:owner
role:holderPerson:owner -.-> role:holderPerson:admin
role:holderPerson:admin -.-> role:holderPerson:referrer
role:global:admin -.-> role:contact:owner
role:contact:owner -.-> role:contact:admin
role:contact:admin -.-> role:contact:referrer
role:global:admin ==> role:relationship:owner
role:relationship:owner ==> role:relationship:admin
role:anchorPerson:admin ==> role:relationship:admin
role:relationship:admin ==> role:relationship:agent
role:holderPerson:admin ==> role:relationship:agent
role:relationship:agent ==> role:relationship:tenant
role:holderPerson:admin ==> role:relationship:tenant
role:contact:admin ==> role:relationship:tenant
role:relationship:tenant ==> role:anchorPerson:referrer
role:relationship:tenant ==> role:holderPerson:referrer
role:relationship:tenant ==> role:contact:referrer

%% granting permissions to roles
role:relationship:owner ==> perm:relationship:DELETE
role:relationship:admin ==> perm:relationship:UPDATE
role:relationship:tenant ==> perm:relationship:SELECT
role:anchorPerson:admin ==> perm:relationship:INSERT

```
